package de.thesmile.android.widget.buttons;

import android.app.Activity;
import android.app.AlertDialog;
import android.appwidget.AppWidgetManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.PorterDuffColorFilter;
import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class ClickOneActivity extends Activity 
{
	private EditText mTitleText;
    private EditText mBodyText;
    
    private int mAppWidgetId = AppWidgetManager.INVALID_APPWIDGET_ID;
    
	
	@Override
	protected void onCreate(Bundle icicle) 
	{
		super.onCreate(icicle);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		
		Intent launchIntent = getIntent();
	    Bundle extras = launchIntent.getExtras();
	    mAppWidgetId = extras.getInt(AppWidgetManager.EXTRA_APPWIDGET_ID, AppWidgetManager.INVALID_APPWIDGET_ID);
	    
		setContentView(R.layout.configure);

		String html =  "Alles lschen" + "<br />" + "<small>" + "(Gedrckt halten)" + "</small>"; 

		mTitleText= (EditText) findViewById(R.id.title);
	    mBodyText = (EditText) findViewById(R.id.body);	         
	    Button confirmButton = (Button) findViewById(R.id.confirm);
	    Button deletetitle   = (Button) findViewById(R.id.deletetitle);
	    Button deleteall     = (Button) findViewById(R.id.deleteall);
	    deleteall.setText(Html.fromHtml(html), TextView.BufferType.SPANNABLE);

	    setTransparent();
	    setButtonFilter();	
	    
        confirmButton.setOnClickListener(mConfirm);  
        confirmButton.setOnTouchListener(mConfirmOnTouch);    
        deletetitle  .setOnClickListener(mDelTitle);
        deletetitle  .setOnTouchListener(mDelTitleOnTouch);
        deleteall    .setOnLongClickListener(mDelAll);  
        deleteall    .setOnTouchListener(mDelAllOnTouch);         
        mTitleText.setText( loadTitlePref( ClickOneActivity.this, mAppWidgetId));
        mBodyText .setText( loadBodyPref(  ClickOneActivity.this, mAppWidgetId));       
	}
	
	public boolean onCreateOptionsMenu(Menu menu) 
	{
		super.onCreateOptionsMenu(menu);
		MenuInflater mi =
		new MenuInflater(getApplication());
		mi.inflate(R.menu.menu, menu);
		return true;
	}
	
	public boolean onOptionsItemSelected(MenuItem item) 
	{
		switch (item.getItemId()) 
		{		
		case R.id.schriftfarben: 
			dialogSchriftfarben();
			return true;
		case R.id.schriftstyle: 
			dialogStyle();
			return true;
		case R.id.schriftfont: 
			dialogFont();
			return true;
		}
		return super.onContextItemSelected(item);
	}
	
	 private void dialogSchriftfarben() 
	 {
		 final CharSequence[] items = {"Rot", "Grn", "Blau", "Gelb", "Schwarz", "Wei", "Transparent", "Grau", "Cyan", "Violett"};
		 DialogInterface.OnClickListener mOnClick = new DialogInterface.OnClickListener()
		 {
				@Override
				public void onClick(DialogInterface dialog, int item) 
				{
					 final Context context = ClickOneActivity.this;
			    	 SharedPreferences.Editor prefs = context.getSharedPreferences("Einstellungen", 0).edit();
			    	 switch (item) 
				 	{	
				 		case 0: prefs.putInt("farbe" + mAppWidgetId, Color.RED); break;
				 		case 1: prefs.putInt("farbe" + mAppWidgetId, Color.GREEN); break;
				 		case 2: prefs.putInt("farbe" + mAppWidgetId, Color.BLUE); break;
				 		case 3: prefs.putInt("farbe" + mAppWidgetId, Color.YELLOW); break;
				 		case 4: prefs.putInt("farbe" + mAppWidgetId, Color.BLACK); break;
				 		case 5: prefs.putInt("farbe" + mAppWidgetId, Color.WHITE); break;	
				 		case 6: prefs.putInt("farbe" + mAppWidgetId, Color.TRANSPARENT); break;
				 		case 7: prefs.putInt("farbe" + mAppWidgetId, Color.GRAY); break;
				 		case 8: prefs.putInt("farbe" + mAppWidgetId, Color.CYAN); break;
				 		case 9: prefs.putInt("farbe" + mAppWidgetId, Color.MAGENTA); break;
			 		 } 	 		    	 
				     prefs.commit();
			         Toast.makeText(context, "\"" + items[item] + "\" gewhlt", Toast.LENGTH_SHORT).show();	
				}          
		  }; 
		 AlertDialog.Builder builder = new AlertDialog.Builder(this);
		 builder.setTitle("Whle eine Widgetschriftfarbe:");
		 builder.setItems(items, mOnClick);

		 AlertDialog alert = builder.create();
		 alert.show();
	}	 	 
	 
	 private void dialogStyle() 
	 {	 
		 
		 final CharSequence[] items = {"Fett", "Fett & Kursiv", "Kursiv", "Normal"};
		 DialogInterface.OnClickListener mOnClick = new DialogInterface.OnClickListener()
		 {
				@Override
				public void onClick(DialogInterface dialog, int item) 
				{
					 final Context context = ClickOneActivity.this;
			    	 SharedPreferences.Editor prefs = context.getSharedPreferences("Einstellungen", 0).edit();
			    	 switch (item) 
				 	{	
				 		case 0: prefs.putInt("style" + mAppWidgetId, Typeface.BOLD); break;
				 		case 1: prefs.putInt("style" + mAppWidgetId, Typeface.BOLD_ITALIC); break;
				 		case 2: prefs.putInt("style" + mAppWidgetId, Typeface.ITALIC); break;
				 		case 3: prefs.putInt("style" + mAppWidgetId, Typeface.NORMAL); break;
			 		 } 	 		    	 
				     prefs.commit();
				     Toast.makeText(context, "\"" + items[item] + "\" gewhlt", Toast.LENGTH_SHORT).show();
				}          
		  }; 
		 AlertDialog.Builder builder = new AlertDialog.Builder(this);
		 builder.setTitle("Whle einen Widgetschriftstyle:");
		 builder.setItems(items, mOnClick);
		
		 AlertDialog alert = builder.create();
		 alert.show();
	}	
	 
	 private void dialogFont() 
	 {	 
		 final CharSequence[] font = {"Monospace", "Serif", "Sans-Serif"};
		 DialogInterface.OnClickListener mFontChoise = new DialogInterface.OnClickListener()
		 {
				public void onClick(DialogInterface dialog, int item) 
				{
					 final Context context = ClickOneActivity.this;
			    	 SharedPreferences.Editor prefs = context.getSharedPreferences("Einstellungen", 0).edit();
			    	 switch (item) 
				 	{	
				 		case 0: prefs.putString("font" + mAppWidgetId, "monospace"); break;
				 		case 1: prefs.putString("font" + mAppWidgetId, "serif"); break;
				 		case 2: prefs.putString("font" + mAppWidgetId, "sans-serif"); break;
			 		 } 	 		    	 
				     prefs.commit();
			         Toast.makeText(context, "\"" + font[item] + "\" gewhlt", Toast.LENGTH_SHORT).show();					
				}          
		  }; 
		 AlertDialog.Builder builder = new AlertDialog.Builder(this);
		 builder.setTitle("Whle einen Widgetschriftstyle:");
		 builder.setItems(font, mFontChoise);
		
		 AlertDialog alert = builder.create();
		 alert.show();
	}	

	static void saveTitlePref(Context context, int appWidgetId, String text) 
	{
	        SharedPreferences.Editor prefs = context.getSharedPreferences("Einstellungen", 0).edit();
	        prefs.putString("title" + appWidgetId, text);
	        prefs.commit();
	}
	 
	 static void saveBodyPref(Context context, int appWidgetId, String body) 
	 {
	        SharedPreferences.Editor prefs = context.getSharedPreferences("Einstellungen", 0).edit();
	        prefs.putString("body"  + appWidgetId, body);
	        prefs.commit();
	 }	 
	static String loadTextFont(Context context, int appWidgetId) 
	{
        SharedPreferences prefs = context.getSharedPreferences("Einstellungen", 0);
        String font = prefs.getString("font" + appWidgetId, "serif");
        return font;
    }
	 
	static int loadTextColor(Context context, int appWidgetId) 
	{
        SharedPreferences prefs = context.getSharedPreferences("Einstellungen", 0);
        int color = prefs.getInt("farbe" + appWidgetId, Color.RED);
        return color;
    }
	
	static int loadTextStyle(Context context, int appWidgetId) 
	{
        SharedPreferences prefs = context.getSharedPreferences("Einstellungen", 0);
        int style = prefs.getInt("style" + appWidgetId, Typeface.NORMAL);
        return style;
    }
	
	static String loadTitlePref(Context context, int appWidgetId) 
	{
        SharedPreferences prefs = context.getSharedPreferences("Einstellungen", 0);
        String prefix = prefs.getString("title" + appWidgetId, null);
        if (prefix != null) {
            return prefix;
        } else {
            return "";
        }
    }
	
	static String loadBodyPref(Context context, int appWidgetId) 
	{
        SharedPreferences prefs = context.getSharedPreferences("Einstellungen", 0);
        String prefix = prefs.getString("body" + appWidgetId, null);
        if (prefix != null) {
            return prefix;
        } else {
            return "";
        }
    }
	
	static void deleteTitlePref(Context context, int appWidgetId) 
	{
		SharedPreferences.Editor prefs = context.getSharedPreferences("Einstellungen", 0).edit();
        prefs.remove("title"  + appWidgetId);
        prefs.commit();
        
    }
	
	static void deleteTitleAndBodyPref(Context context, int appWidgetId) 
	{
		SharedPreferences.Editor prefs = context.getSharedPreferences("Einstellungen", 0).edit();
        prefs.remove("title" + appWidgetId);
        prefs.remove("body"  + appWidgetId);
        prefs.remove("farbe" + appWidgetId);
        prefs.remove("style" + appWidgetId);
        prefs.remove("font"  + appWidgetId);
        prefs.commit();
    }
	
	void setTransparent() 
	{
		Drawable d;	    
	    d= findViewById(R.id.title).getBackground();
	    d.setAlpha(100);
	    d= findViewById(R.id.body).getBackground();
	    d.setAlpha(100);
	    d= findViewById(R.id.confirm).getBackground();
	    d.setAlpha(200);
	    d= findViewById(R.id.deletetitle).getBackground();
	    d.setAlpha(200);
	    d= findViewById(R.id.deleteall).getBackground();
	    d.setAlpha(200);   
    }
	
	void setButtonFilter() 
	{
		PorterDuffColorFilter filter;
	    Drawable d;
	    d= findViewById(R.id.deleteall).getBackground();  
	    filter = new PorterDuffColorFilter(Color.argb(100, 255, 0, 0), PorterDuff.Mode.SRC_ATOP);  
	    d.setColorFilter(filter);  
	    d= findViewById(R.id.deletetitle).getBackground();  
	    filter = new PorterDuffColorFilter(Color.argb(100, 255, 100, 100), PorterDuff.Mode.SRC_ATOP);  
	    d.setColorFilter(filter); 
	    d= findViewById(R.id.confirm).getBackground();  
	    filter = new PorterDuffColorFilter(Color.argb(100, 0, 255, 0), PorterDuff.Mode.SRC_ATOP);  
	    d.setColorFilter(filter); 
    }
	
	private OnClickListener mConfirm = new OnClickListener()
	{
    	public void onClick(View view) 
    	{
    		final Context context = ClickOneActivity.this;
    		
    		saveTitlePref( context, mAppWidgetId, mTitleText.getText().toString());
    		saveBodyPref(  context, mAppWidgetId,  mBodyText.getText().toString());

            AppWidgetManager appWidgetManager = AppWidgetManager.getInstance(context);
            ButtonWidget.updateAppWidget(context, appWidgetManager, mAppWidgetId);

    	    setResult(RESULT_OK);
    	    finish();
    	}          
    }; 
    
    private OnClickListener mDelTitle = new OnClickListener()
    {
    	public void onClick(View view) 
    	{
    		final Context context = ClickOneActivity.this;  
    		
    		deleteTitlePref(context,mAppWidgetId);
    		
            mTitleText.setText( loadTitlePref( context, mAppWidgetId));
    	}          
    };  
    
    private OnLongClickListener mDelAll = new OnLongClickListener() {		
		@Override
		public boolean onLongClick(View v) {
			final Context context = ClickOneActivity.this;  
    		
    		deleteTitleAndBodyPref(context,mAppWidgetId);
    		
            mTitleText.setText( loadTitlePref( context, mAppWidgetId));
            mBodyText .setText( loadBodyPref(  context, mAppWidgetId));
			return false;
		}
	};  
    
    private OnTouchListener mConfirmOnTouch = new OnTouchListener() 
    {		
		@Override
		public boolean onTouch(View v, MotionEvent event) 
		{
			if(event.getAction() == MotionEvent.ACTION_DOWN)
			{
			    Drawable d = findViewById(R.id.confirm).getBackground();  
			    findViewById(R.id.confirm).invalidateDrawable(d);  
			    d.clearColorFilter();
			}
			else
			{
				setButtonFilter();
			}
			return false;
		}
	};
	private OnTouchListener mDelTitleOnTouch = new OnTouchListener() 
    {		
		@Override
		public boolean onTouch(View v, MotionEvent event) 
		{
			if(event.getAction() == MotionEvent.ACTION_DOWN)
			{
			    Drawable d = findViewById(R.id.deletetitle).getBackground();  
			    findViewById(R.id.deletetitle).invalidateDrawable(d);  
			    d.clearColorFilter();
			}
			else
			{
				setButtonFilter();
			}
			return false;
		}
	};
	private OnTouchListener mDelAllOnTouch = new OnTouchListener() 
    {		
		@Override
		public boolean onTouch(View v, MotionEvent event) 
		{
			if(event.getAction() == MotionEvent.ACTION_DOWN)
			{
			    Drawable d = findViewById(R.id.deleteall).getBackground();  
			    findViewById(R.id.deleteall).invalidateDrawable(d);  
			    d.clearColorFilter();
			}
			else
			{
				setButtonFilter();
			}
			return false;
		}
	};
	
	 @Override
	 protected void onPause() 
	 {
	        super.onPause();
	        final Context context = ClickOneActivity.this;  
	        saveTitlePref( context, mAppWidgetId, mTitleText.getText().toString());
    		saveBodyPref(  context, mAppWidgetId,  mBodyText.getText().toString());
            AppWidgetManager appWidgetManager = AppWidgetManager.getInstance(context);
            ButtonWidget.updateAppWidget(context, appWidgetManager, mAppWidgetId);
            finish();
	  }
	 
	 @Override
	 public boolean onKeyDown(int keyCode, KeyEvent event) 
	 {
		 Log.d(this.getClass().getName(), "back button pressed" + event.getKeyCode());
		 Log.d(this.getClass().getName(), "back button pressed" + KeyEvent.KEYCODE_BACK);
	     if ((keyCode == KeyEvent.KEYCODE_BACK)) 
	     {	    	 
	    	final Context context = ClickOneActivity.this;  
	        saveTitlePref( context, mAppWidgetId, mTitleText.getText().toString());
    		saveBodyPref(  context, mAppWidgetId,  mBodyText.getText().toString());
            AppWidgetManager appWidgetManager = AppWidgetManager.getInstance(context);
            ButtonWidget.updateAppWidget(context, appWidgetManager, mAppWidgetId);
            Log.d(this.getClass().getName(), "back button pressed");
            finish();            

            return true;
	     }
	     return super.onKeyDown(keyCode, event);
	 }

}
